''***************************************
''*  Graphics Demo                      *
''*  Author: Chip Gracey                *
''*  Modified for demo by Erik Friesen  *
''*  Copyright (c) 2005 Parallax, Inc.  *               
''*  See end of file for terms of use.  *               
''***************************************


CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  _stack = ($4000  ) >> 2   'accomodate display memory and stack

  x_tiles = 15
  y_tiles = 8

  paramcount = 14       
  bitmap_base = $4000
  
  lines = 5
  thickness = 2
  

VAR

  byte  x[lines]
  byte  y[lines]
  byte  xs[lines]
  byte  ys[lines]
  long  lcdpointer

OBJ

  gr   : "graphics"
  text :"T6963_240x128"

PUB start | i, j, k, kk, dx, dy, pp, pq, rr, numx, numchr ,a,b,c,tot,d,tot2,tmp

  lcdpointer:=text.Start(30,11,10,9,8,7,0,1)
  'text.start
  repeat 100
    if a++==1000
      a:=0
    text.out($1)
    text.str(string($d,1,"Dcml pnt 2 ",$d,2,$a,10))
    text.dec(a,2,5)
    text.str(string($d,3,$b,1,"Size 3"))
    text.str(string($d,4,$b,1,"Size 4"))
    text.box(18,80,30,110,0,1)
    if a&%10000
      text.out($c1)
    else
      text.out($c2)
    text.str(string($d,1,$b,14,$a,14,$b,2,$e,4,$f,1,"Box",$c1))
    text.updatelcd


  'init bouncing lines
  i := 1001
  j := 123123
  k := 8776434
  repeat i from 0 to lines - 1
    x[i] := ?j // 64
    y[i] := k? // 48
    repeat until xs[i] := k? ~> 29
    repeat until ys[i] := ?j ~> 29

  gr.start
  gr.setup(15, 8, 128, 64, bitmap_base)

  repeat

    'clear bitmap
    gr.clear

    'draw spinning triangles
    gr.colorwidth(1,0)
    repeat i from 1 to 8
      gr.vec(0, 0, (k & $7F) << 3 + i << 5, k << 6 + i << 8, @vecdef)

    'draw expanding mouse crosshairs
    gr.colorwidth(1,k>>2)
    gr.arc(0,0,80,30,-k<<5,$2000/9,9,0)

    'draw expanding pixel halo
    gr.colorwidth(1,k)
    gr.arc(0,0,80,30,-k<<5,$2000/9,9,0)

    
    'step bouncing lines
    repeat i from 0 to lines - 1
      if ||~x[i] > 120
        -xs[i]
      if ||~y[i] > 64
        -ys[i]
      x[i] += xs[i]
      y[i] += ys[i]

    'draw bouncing lines
    gr.colorwidth(1,thickness)
    gr.plot(~x[0], ~y[0])
    repeat i from 1 to lines - 1
      gr.line(~x[i],~y[i])
    gr.line(~x[0], ~y[0])

    'draw spinning stars and revolving crosshairs and dogs
   ' gr.colorwidth(1,0)
    'repeat i from 0 to 7
    ' gr.vecarc(40,15,15,15,-(i<<10+k<<5),$40,-(k<<7),@vecdef2)

    gr.colorwidth(1,0)
    repeat i from 0 to 7
      gr.vecarc(70,30,25,25,-(i<<10+k<<6),$40,-(k<<7),@vecdef2)
      gr.pixarc(-80,-40,30,30,i<<10+k<<6,0,@pixdef2)
      gr.pixarc(-80,-40,20,20,-(i<<10+k<<6),0,@pixdef)
    'draw small box with text
    gr.colorwidth(1,4)
    gr.box(30,-60,70,12)
    gr.textmode(1,1,6,5)
    gr.colorwidth(0,0)
    gr.text(62,-54,@pchip)

    'draw incrementing digit
    if not ++numx & 7
      numchr++
    if numchr < "0" or numchr > "9"
      numchr := "0"
    gr.textmode(4,4,4,4)
    gr.colorwidth(1,4)
    gr.text(-110,8,@numchr)


    gr.copy($6000)
    text.writegraphics
    text.updatelcd
     waitcnt(1000000+cnt)

   k++
    

DAT


vecdef                  word    $4000+$2000/3*0         'triangle
                        word    50
                        word    $8000+$2000/3*1+1
                        word    50
                        word    $8000+$2000/3*2-1
                        word    50
                        word    $8000+$2000/3*0
                        word    50
                        word    0

vecdef2                 word    $4000+$2000/12*0        'star
                        word    50
                        word    $8000+$2000/12*1
                        word    20
                        word    $8000+$2000/12*2
                        word    50
                        word    $8000+$2000/12*3
                        word    20
                        word    $8000+$2000/12*4
                        word    50
                        word    $8000+$2000/12*5
                        word    20
                        word    $8000+$2000/12*6
                        word    50
                        word    $8000+$2000/12*7
                        word    20
                        word    $8000+$2000/12*8
                        word    50
                        word    $8000+$2000/12*9
                        word    20
                        word    $8000+$2000/12*10
                        word    50
                        word    $8000+$2000/12*11
                        word    20
                        word    $8000+$2000/12*0
                        word    50
                        word    0

pixdef                  word                            'crosshair
                        byte    2,7,3,3
                        word    %%00333000,%%00000000
                        word    %%03020300,%%00000000
                        word    %%30020030,%%00000000
                        word    %%32222230,%%00000000
                        word    %%30020030,%%02000000
                        word    %%03020300,%%22200000
                        word    %%00333000,%%02000000

pixdef2                 word    'dog
                        byte    1,4,0,3
                        word    %%20000022
                        word    %%02222222
                        word    %%02222200
                        word    %%02000200

pchip                   byte    "T6963 demo",0        'text

{{

+------------------------------------------------------------------------------------------------------------------------------+
                                                   TERMS OF USE: MIT License                                                                                                              
+------------------------------------------------------------------------------------------------------------------------------
Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation     
files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,    
modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software
is furnished to do so, subject to the following conditions:                                                                   
                                                                                                                              
The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
                                                                                                                              
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE          
WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR         
COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,   
ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         
+------------------------------------------------------------------------------------------------------------------------------+
}}